import pGUI.classes.*; //<>// //<>//
import pGUI.core.*;
import java.util.Collections;
import java.util.Comparator;

Frame f;
Textbox tb;
ListView lw;
Button b;
Button b2;
Label description1;
Label description2;

Dictionary dc;


void setup() {
  size(400, 400);

  f = new Frame(this);
  tb = new Textbox(this);
  lw = new ListView(this);
  b = new Button(this);
  b2 = new Button(this);
  description1 = new Label(this);
  description2 = new Label(this);


  f.add(tb, lw, b, b2, description1, description2); //add components to main frame

  f.setGradient(color(220, 224, 240), color(255));


  description1.setPosition(20, 20);
  description1.setText("Start to enter text and select");
  description1.setFontSize(16);

  description2.setPosition(20, 40);
  description2.setText("suggestions to complete word");
  description2.setFontSize(16);
  description2.setHeight(30);


  tb.setPosition(20, 90);
  tb.setWidth(300);
  tb.addTextChangedListener("textchanged"); //add listen for text changes
  tb.Focus();

  lw.addItemChangedListener("itemchanged"); //listen for item changes
  lw.setPosition(20, tb.getHeight() + 20 + tb.getY());
  lw.setWidth(300);
  lw.setBorderWidth(1);
  lw.setBorderColor(color(100));


  b.setPosition(20, 300);
  b.setText("List all Words");
  b.addEventListener("press", "listAllWords");
  b.setFontSize(14);

  b2.setPosition(110, b.getY());
  b2.setText("add Words");
  b2.addEventListener("press", "addAllWords");
  b2.setFontSize(14);
  b2.setVisible(false);

  //initialize dict
  dc = new Dictionary("dict.txt");
}


//draw is empty because everything is handled by the gui library but 
// draw can't be removed, because PApplet won't to any updating without it
void draw() {
}



// retrieve last word of string (look for spaces)
String getLastWord (String text) {
  if (text.length() > 1) {
    int i = text.length()-2;
    while (i > 0) {
      if (text.charAt(i) == ' ' || text.charAt(i) == '/') break;
      i--;
    }
    return trim(text.substring(i));
  }
  return "";
}


// retrieve starting position of last word in string
int getLastWordIndex(String text) {
  return max(text.lastIndexOf(' ') + 1, text.lastIndexOf('/') + 1);
}


// text change event, called by textbox
void textchanged() {
  dc.searchWord(getLastWord(tb.getText().substring(0, tb.getCursorPosition())));
  lw.clear();
  for (int i = 0; i < dc.suggestions.size(); i++) {
    lw.add(trim(dc.suggestions.get(i).word));
  }


  if (tb.getKey() == ' ') {
    String lastWord = getLastWord(tb.getText().substring(0, tb.getCursorPosition()));
    if (lastWord.length() > 3) {
      dc.addWord(lastWord);
    }
  }

  if (tb.getKey() == '\n') {
    lw.setSelectedItem(0);
  }
  tb.Focus();
}



//item changed event, called by listview
void itemchanged() {

  String word = lw.getSelectedItem().getText();
  int index = getLastWordIndex(tb.getText().substring(0, tb.getCursorPosition()));
  String lastWord = getLastWord(tb.getText().substring(0, tb.getCursorPosition()));

  String text1 = tb.getText().substring(0, index) + word + " ";
  String text2 = trim(tb.getText().substring(index + lastWord.length()));

  tb.setText(text1 + text2);
  tb.setCursorPosition(text1.length());

  dc.addWord(word); //increment rank of this word


  textchanged();
  tb.Focus();
}



// button click event for listing all word of dict in listview
void listAllWords() {
  lw.clear();

  dc.suggestAllWords();

  for (int i = 0; i < dc.suggestions.size(); i++) {
    lw.add(trim(dc.suggestions.get(i).word));
  }
}


//function for adding all words from textbox to dict. just used for building a database
void addAllWords() {
  String[] list = tb.getText().split(" ");
  for (int i = 0; i < list.length; i++) {
    dc.addWord(list[i]);
  }
}



//this will be called by the PApplet when closing the application
//We need to store all changes before the app dies

void exit() {
  dc.saveData();
}
