#include "FlexSensor.h";

int onLedPin = 3;
int sleepLedPin = 5;

FlexSensor myFlexSensor(7, 50);


void setup() {
  Serial.begin(9600);
  Serial.println("FLXSNSR");
  myFlexSensor.setLedPins(onLedPin, sleepLedPin); //set pin numbers to set lights indicating the state of the arduino
  
}


void loop() {
  if (myFlexSensor.isActive()) { //only run code, when program is "active"
    if (!myFlexSensor.isCalibrated()) {
      myFlexSensor.calibrate();
    } else {
      myFlexSensor.readData();
      delay(100);
    }
  }
}



String input;

void serialEvent() {
  
  char inputChar;
  int inputInt;
  
  while (Serial.available()) {
    inputChar = Serial.read();
    input += inputChar;
    
    if (inputChar == '\n') {
      if (input.toInt()) {
        switch (input.toInt()) {
          case 1: myFlexSensor.setActive(1); break;  //set arduino working state to active
          case 2: myFlexSensor.setActive(0); break;  //set arduino working state to inactive
          case 3: myFlexSensor.reset(); break;//call a reset on variables. also recalibrate
          case 4: myFlexSensor.enableBothDirections(1); break;
          case 5: myFlexSensor.enableBothDirections(0); break;
          case 6: myFlexSensor.enableLongClick(1); break;
          case 7: myFlexSensor.enableLongClick(0); break;
          case 8: myFlexSensor.enableContinuousValues(1); break;
          case 9: myFlexSensor.enableContinuousValues(0); break;
          default: Serial.println("error");
        }
      } else if (input.startsWith("t")) { //set tolerance
        if (input.substring(1).toInt() > -1) {
          myFlexSensor.setTolerance(input.substring(1).toInt());
        } else {
          Serial.println("error w/t");
        }
      } else if ( input.startsWith("s")) { //set short thresh
        if (input.substring(1).toInt() > -1) {
          myFlexSensor.setShortThresh(input.substring(1).toInt());
        } else {
          Serial.println("error w/sT");
        }
      } else if ( input.startsWith("l")) { //set long thresh
        if (input.substring(1).toInt() > -1) {
          myFlexSensor.setLongThresh(input.substring(1).toInt());
        } else {
          Serial.println("error w/lT");
        }
      } else {
        Serial.println("synerror");
      }
      
      input = "";
    }
  }
}
