package pGUI.core;

import processing.core.*;
import processing.event.*;

import java.awt.EventQueue;
import java.awt.Color.*;

import pGUI.classes.*;

public class Button extends Control {

	public Button(PApplet pa) {
		super(pa);
		addMouseListener();
		setPadding(10);
		BorderWidth = 1;
	}

	/*
	 * DRAWING AND RENDERING
	 */

	@Override
	protected void render() {
		pg = papplet.createGraphics(1, 1);
		pg.beginDraw();
		pg.textSize(FontSize);
		Width = (int) PApplet.constrain(pg.textWidth(Text) + PaddingLeft + PaddingRight, MinWidth, MaxWidth);
		Height = (int) PApplet.constrain(FontSize + pg.textDescent() + PaddingBottom + PaddingTop, MinHeight,
				MaxHeight);

		pg = papplet.createGraphics(Width, Height);

		pg.beginDraw();

		drawDefaultBackground();

		drawDefaultText();
		pg.endDraw();
		// changedVisuals = true;
	}

	/*
	 * STYLE SETTING METHODS
	 */

	// automatically set HoverColor and PressedColor
	@Override
	public void setBackgroundColor(int clr) {
		setBackgroundColorsAutomatically(clr);
	}

	/*
	 * EVENT METHODS
	 */
	@Override
	protected void enter(MouseEvent e) {
		VisualBackgroundColor = HoverColor;
		update();
	}

	@Override
	protected void exit(MouseEvent e) {
		VisualBackgroundColor = BackgroundColor;
		update();
	}

	@Override
	protected void press(MouseEvent e) {
		Focus();
		VisualBackgroundColor = PressedColor;
		update();
	}

	@Override
	protected void release(MouseEvent e) {
		VisualBackgroundColor = HoverColor;
		update();
	}
}