package pGUI.core;

import processing.core.*;
import processing.event.*;

import pGUI.classes.*;

public class HFlowContainer extends Container {

	public HFlowContainer(PApplet pa) {
		super(pa);
		BorderWidth = 0;
	}

	protected boolean Break = true;

	@Override
	protected void render() {
		// if AutoSize is on, first get minimal dimensions
		if (AutoSize) {
			setAutoSize();
		}

		pg = papplet.createGraphics(Width, Height);
		pg.beginDraw();
		drawDefaultBackground();

		int usedSpace = PaddingLeft;

		for (int i = 0; i < Content.size(); i++) {
			Control c = Content.get(i);

			if (c.Visible) {
				c.Bounds.X0 = this.Bounds.X0 + usedSpace + c.MarginLeft;
				c.Bounds.Y0 = this.Bounds.Y0 + c.MarginTop + PaddingTop;
				// crop overflow
				c.Bounds.X = Math.min(c.Bounds.X0 + c.Width, this.Bounds.X);
				c.Bounds.Y = Math.min(c.Bounds.Y0 + c.Height, this.Bounds.Y);
				// constrain after computing X,Y so no data will be lost by constraining
				c.Bounds.X0 = Math.max(c.Bounds.X0, this.Bounds.X0);
				c.Bounds.Y0 = Math.max(c.Bounds.Y0, this.Bounds.Y0);

				if (c.changedVisuals) {
					c.changedVisuals = false;
					c.render();
				}

				pg.image(c.getGraphics(), usedSpace + c.MarginLeft, c.MarginTop + PaddingTop);
				usedSpace += (c.Width + c.MarginLeft + c.MarginRight);
			}
		}

		pg.endDraw();
	}
}
