


package pGUI.core;

import processing.core.*;
import processing.event.*;

import pGUI.classes.*;

public class ListItem extends Control {

  public ListItem(PApplet pa) {
    super(pa);
    addMouseListener();
    setPadding(3);
    PaddingLeft = 5;
    BorderWidth = 1;
  }

  @Override
    protected void render() {
    Width = PApplet.max(1, parent.Width - MarginLeft - MarginRight - 5);
    Height = (int) (FontSize * 1.5) + PaddingTop + PaddingBottom;
    pg = papplet.createGraphics(Width, Height);

    pg.beginDraw();
    pg.fill(VisualBackgroundColor);
    pg.stroke(BorderColor);
    pg.strokeWeight(BorderWidth);
    if (Background == COLOR) {
      pg.rect(BorderWidth, BorderWidth, Width - 2 * BorderWidth, Height - 2 * BorderWidth);
    }
    drawDefaultText();

    pg.endDraw();
  }

  /*
   * SETTER
   */

  @Override
    protected void enter(MouseEvent e) {
    VisualBackgroundColor = HoverColor;
    update();
  }

  @Override
    protected void exit(MouseEvent e) {
    VisualBackgroundColor = BackgroundColor;
    update();
  }

  @Override
    protected void press(MouseEvent e) {
    ((ListView) parent).itemSelected((Control) this);
    update();
  }

  @Override
    protected void release(MouseEvent e) {
    update();
  }

  @Override
    protected void drag(MouseEvent e) {
    //((ListView) parent).itemSelected((Control) this);
  }
}