
package pGUI.core;

import processing.core.*;
import processing.event.*;

import pGUI.classes.*;

public class MenuContainer extends HFlowContainer {

	protected Control openMenu;
	protected int normalHeight = 25;

	public MenuContainer(PApplet pa) {
		super(pa);
		Height = 25;
		setBackgroundColor(-3618616);
		Z = 5;

		addMouseListener();
	}

	@Override
	protected void render() {
		Width = frame.Width;

		if (openMenu != null)
			openMenu.render();

		pg = papplet.createGraphics(Width, openMenu != null ? openMenu.Height + 5 : normalHeight);
		pg.beginDraw();
		Height = normalHeight;
		drawDefaultBackground();

		if (openMenu != null) {
			Height = openMenu.Height;
		}
		int usedSpace = PaddingLeft;

		for (int i = 0; i < Content.size(); i++) {
			Control c = Content.get(i);

			if (c.Visible) {
				c.Bounds.X0 = this.Bounds.X0 + usedSpace + c.MarginLeft;
				c.Bounds.Y0 = this.Bounds.Y0 + c.MarginTop + PaddingTop;
				// crop overflow
				c.Bounds.X = Math.min(c.Bounds.X0 + c.Width, this.Bounds.X);
				c.Bounds.Y = Math.min(c.Bounds.Y0 + c.Height, this.Bounds.Y);
				// constrain after computing X,Y so no data will be lost by constraining
				c.Bounds.X0 = Math.max(c.Bounds.X0, this.Bounds.X0);
				c.Bounds.Y0 = Math.max(c.Bounds.Y0, this.Bounds.Y0);

				if (c.changedVisuals) {
					c.changedVisuals = false;
					c.render();
				}

				pg.image(c.getGraphics(), usedSpace + c.MarginLeft, c.MarginTop + PaddingTop);
				usedSpace += (c.Width + c.MarginLeft + c.MarginRight);
			}
		}

		pg.endDraw();
	}

	protected void openMenu(MenuStrip ms) {
		for (int i = 0; i < Content.size(); i++) {
			if (Content.get(i) != ms)
				((MenuStrip) Content.get(i)).closeDropDown();
		}
		this.openMenu = ms;
		update();
	}

	protected void closeMenu() {
		this.openMenu = null;
		update();
	}
}