
package pGUI.core;

import processing.core.*;
import processing.event.*;

import pGUI.classes.*;

public class MenuItem extends Control {

	// width that would be used
	protected int contentWidth;

	protected Shortcut shortcut;

	public MenuItem(PApplet pa) {
		super(pa);
		setBackgroundColor(0);
		HoverColor = 671088660;
		addMouseListener();
		setPadding(3);
		BorderWidth = 0;
		TextAlign = 37;
		FontSize = 15;
		PaddingLeft = 27;
		PaddingRight = 12;
		PaddingBottom = 4;

		autosize();
	}

	@Override
	protected void render() {
		Width = Math.max(1, parent.Width - MarginLeft - MarginRight);
		pg = papplet.createGraphics(Width, Height);

		pg.beginDraw();
		pg.noStroke();

		if (VisualBackgroundColor != 0) {
			pg.fill(VisualBackgroundColor);
		} else {
			pg.noFill();
		}
		if (Background == COLOR) {
			pg.rect(BorderWidth, BorderWidth, Width - 2 * BorderWidth, Height - 2 * BorderWidth);
		}

		String TextBKP = Text;

		if (shortcut != null) {
			String shortcutText = shortcutToText();
			Text += "    " + shortcutText;
		}

		drawDefaultText();
		Text = TextBKP;
		// override parents constrains on bounds

		pg.endDraw();
	}

	protected String shortcutToText() {
		if (shortcut != null)
			return (shortcut.Control ? "Ctrl+" : "") + (shortcut.Shift ? "Shift" : "") + (shortcut.Alt ? "Alt" : "")
					+ shortcut.Key;
		else
			return "";
	}

	/*
	 * SETTER
	 */
	@Override
	protected void autosize() {
		Height = (int) (FontSize * 1.5) + PaddingTop + PaddingBottom;
	}

	@Override
	protected void enter(MouseEvent e) {
		VisualBackgroundColor = HoverColor;
		update();
	}

	@Override
	protected void exit(MouseEvent e) {
		VisualBackgroundColor = BackgroundColor;
		update();
	}

	@Override
	protected void press(MouseEvent e) {
		((MenuStrip) parent).itemSelected((Control) this);
		frame.chokeMouseListeners = true;
		update();
	}

	@Override
	protected void release(MouseEvent e) {
		update();
	}
}
