
package pGUI.core;

import processing.core.*;
import processing.event.*;

import pGUI.classes.*;

public class Switch extends Checkbox {

	protected int a;

	public Switch(PApplet pa) {
		super(pa);
		Width = 50;
		Height = 50;

		Size = 20;
		Height = Size;

		UncheckedBackgroundColor = Color.colors(160);
		CheckedBackgroundColor = Color.colors(46, 116, 122);
		SwitchForegroundColor = Color.colors(100, 50, 50);
		setBackgroundColor(0);
		actualPosition = (int) (checked ? (1.75 * Size - (Size - Size / 4) / 2 - (Size / 4) + 1)
				: ((Size - Size / 4) / 2 + (Size / 4) - 1));
	}

	protected void render() {
		pg = papplet.createGraphics(Width, Height);
		pg.beginDraw();

		if (VisualBackgroundColor != 0) {
			pg.background(VisualBackgroundColor);
		}

		pg.noStroke();

		pg.fill(checked ? CheckedBackgroundColor : UncheckedBackgroundColor);
		pg.rect(0, Height / 2 - Size / 2, 1.75f * Size, Size, 100);

		int xPos = (int) (checked ? (1.75 * Size - (Size - Size / 4) / 2 - (Size / 4) + 1)
				: ((Size - Size / 4) / 2 + (Size / 4) - 1));
		aimedPosition = (int) (checked ? (1.75 * Size - (Size - Size / 4) / 2 - (Size / 4) + 1)
				: ((Size - Size / 4) / 2 + (Size / 4) - 1));

		animate();
		// draw shadow
		pg.fill(0);
		pg.ellipse(actualPosition, Height / 2 + 1, Size - Size / 4, Size - Size / 4);

		// draw point
		pg.fill(SwitchForegroundColor);
		pg.ellipse(actualPosition, Height / 2, Size - Size / 4, Size - Size / 4);

		pg.textSize(FontSize);
		pg.fill(ForegroundColor);
		pg.textAlign(37, 3);
		pg.text(Text, Size * 1.75f + Size / 4 + PaddingLeft, Height / 2);

		if (!Enabled) {
			pg.fill(150, 150);
			pg.rect(0, Height / 2 - Size / 2, 1.75f * Size, Size, 100);
		}

		pg.endDraw();
	}

	// used for animating the switch movement
	protected int aimedPosition;
	protected int actualPosition;

	protected void animate() {
		if (actualPosition < aimedPosition && checked) {
			actualPosition = Math.min(actualPosition + Size / 20, aimedPosition);
			update();
		} else if (actualPosition > aimedPosition && !checked) {
			actualPosition = Math.max(actualPosition - Size / 20, aimedPosition);
			update(); // update again next frame
		}
	}
}
