/*package pGUI.core;

import processing.core.*;
import processing.event.*;

import java.lang.reflect.Method;

import pGUI.classes.*;

public class Textbox extends HScrollContainer {

	protected int Cursor = PApplet.TEXT;
	protected int SelectionColor = 200;
	protected int CursorColor = 70;
	protected String Hint = "";

	protected int cursorPosition = 0;

	protected boolean autoScroll; // autoscroll to cursor when text changed, dont set it

	protected int cursorTime; // variable is used to meausure time between to cursor renders and create the
								// blink animation
	protected boolean displayCurs = true;
	protected boolean initialized = false;

	protected int numberOfListeners = 6; // add textChangedListener

	public Textbox(PApplet pa) {
		super(pa);
		ForegroundColor = 0;

		BackgroundColor = 220;
		HoverColor = 220;
		VisualBackgroundColor = BackgroundColor;
		FontSize = 20;
		Width = 100;
		Height = 20;
		PaddingTop = 3;
		padding(3);
		overridesParentsShortcuts = true;
		// addMouseListener(); already done by HScrollContainer

		// need to create new array because parents constructor doesn't know about the
		// new numberOfListeners
		registeredListeners = new boolean[numberOfListeners];
		registeredMethods = new Method[numberOfListeners];
		registeredMethodWithArgs = new boolean[numberOfListeners];

		// cursor animation:
		papplet.registerMethod("pre", this);
	}

	@Override
	public void render() {
		if (!initialized) {
			cursorTime = papplet.millis();
			initialized = true;
		}
		pg = papplet.createGraphics(Width, Height); // create graphics so autosize can use it
		pg.beginDraw();
		autoHeight(); // set height according to font size
		pg = papplet.createGraphics(Width, Height); // create graphics with new dimensions
		pg.beginDraw();
		pg.background(VisualBackgroundColor);
		// draw 3D-border
		pg.stroke(70);
		pg.line(0, 0, Width + 5, 0);
		pg.line(0, 0, 0, Height);
		// prepare text
		pg.textSize(FontSize);
		pg.textAlign(PApplet.LEFT, PApplet.TOP);
		pg.fill(ForegroundColor);

		// do this before drawing cursor!! - needs new fullScrollWidth
		fullScrollWidth = (int) pg.textWidth(Text) + PaddingLeft + PaddingRight;

		// draw cursor
		if (this.Focused && displayCurs) {
			drawCursor();
		}

		// draw text
		if (!Text.equals("")) {
			pg.text(Text, PaddingLeft - scrollPositionX, PaddingTop);
		} else {
			pg.fill(120);
			pg.text(Hint, PaddingLeft, PaddingTop);
		}

		// draw scrollbar
		float scrollbarWidth = (float) Width / fullScrollWidth * Width;

		if (scrollbarWidth < Width) { // don't display scroll-bar when there's nothign to scroll
			float scrollBarX = PApplet.constrain(
					scrollPositionX * (Width - scrollbarWidth) / (float) (fullScrollWidth - Width), 1,
					Width - scrollbarWidth - 2);
			pg.fill(150);
			pg.noStroke();
			pg.rect(scrollBarX, Height - 5, scrollbarWidth, 3, 15);
		}
		pg.endDraw();
	}

	protected void autoHeight() {
		Height = FontSize + (int) pg.textDescent() + PaddingTop + PaddingBottom;
	}

	//
	//  Cursor managing
	//

	// cursor blink animation
	public void pre() {
		if (this.Focused) {
			int t = papplet.millis();
			if (t - cursorTime > 500) {
				displayCurs = !displayCurs;
				cursorTime = t;
				update();
			}
		}
	}

	protected void drawCursor() {
		int start = 0;
		int stop = cursorPosition;// -lineBreaks.get(index-1)+1;
		String a = Text.substring(start, stop);
		float wordWidth = pg.textWidth(a) + (float) 0.5;
		int cursorHeight = FontSize;

		// do this before drawing the cursor - scrollPositionX has to be set first!!
		if (autoScroll) {
			if (wordWidth - scrollPositionX > Width - PaddingRight - PaddingLeft) { // cursor left visible box at the
																					// right
				setScrollPositionX(wordWidth - Width + PaddingRight + PaddingLeft);
			} else if (wordWidth < scrollPositionX + PaddingLeft) { // cursor left visible box at the left
				setScrollPositionX(wordWidth);
			}
			autoScroll = false;
		}
		pg.stroke(CursorColor);
		pg.line(PaddingLeft + wordWidth - scrollPositionX, PaddingTop, wordWidth + PaddingLeft - scrollPositionX,
				cursorHeight + PaddingTop);
	}

	//
	 // EDIT TEXT
	 //

	protected void append(char c) {
		cursorPosition += 1;
		Text = Text.substring(0, cursorPosition - 1) + c + Text.substring(cursorPosition - 1);

		update();
		textChanged();
	}

	protected void append(String s) {
		cursorPosition += s.length();
		Text = Text.substring(0, cursorPosition - 1) + s + Text.substring(cursorPosition - 1);

		update();
		textChanged();
	}

	// deprecated
	protected void setContent(String newContent) {
		this.Text = newContent;
		update();
		textChanged();
	}

	protected void backspace() {
		if (Text.length() > 0 && cursorPosition >= 1) {

			Text = Text.substring(0, cursorPosition - 1) + Text.substring(cursorPosition);
			cursorPosition--;
			update();
			textChanged();
		}
	}

	protected void delete() {
		if (Text.length() > cursorPosition) {

			Text = Text.substring(0, cursorPosition) + Text.substring(cursorPosition + 1);
			update();
			textChanged();
		}
	}

	protected void textChanged() {
		cursorTime = papplet.millis();
		displayCurs = true;
		autoScroll = true;
		// handleRegisteredEventMethod(5, null);
	}

	protected void moveCursorBy(int i) {
		cursorPosition = PApplet.constrain(cursorPosition + i, 0, Text.length());
		update();
		textChanged();
	}

	protected void moveCursorTo(int i) {
		cursorPosition = PApplet.constrain(i, 0, Text.length());
		update();
		textChanged();
	}

	//
	 // GETTER AND SETTER
	 //

	public void setCursorColor(int clr) {
		this.CursorColor = clr;
		update();
	}

	public void setCursorPosition(int p) {
		this.cursorPosition = p >= 0 ? (p <= Text.length() ? p : Text.length()) : 0;
		update();
	}

	public void setSelectionColor(int clr) {
		SelectionColor = clr;
	}

	public void setHint(String h) {
		this.Hint = h;
	}

	public int getCursorColor() {
		return CursorColor;
	}

	public int getCursorPosition() {
		return cursorPosition;
	}

	public int getSelectionColor() {
		return SelectionColor;
	}

	public String getHint() {
		return Hint;
	}

	///
	 // EVENT METHODS
	 //
	public void addTextChangedListener(String methodName) { // Beware! At the moment this also reacts to setting the
															// cursor
		registerEventMethod(5, methodName);
	}

	public void removeTextChangedListener() {
		deregisterEventMethod(5);
	}

	@Override
	protected void enter(MouseEvent e) {
		papplet.cursor(Cursor);
		VisualBackgroundColor = HoverColor;
		update();
	}

	@Override
	protected void exit(MouseEvent e) {
		papplet.cursor(0);
		VisualBackgroundColor = BackgroundColor;
		update();
	}

	@Override
	public void press(MouseEvent e) {
		int mX = e.getX();
		int mY = e.getY();

		// set cursor by clicking
		{
			int clickedPos = mX - Bounds.X0 + scrollPositionX - PaddingLeft; // relative to textbox origin and
																				// considering fullScrollWidth
			float wide = 0;
			for (int i = 0; i < Text.length(); i++) {
				float letterWidth = pg.textWidth(Text.substring(i, i + 1));
				wide += letterWidth;
				if (wide - letterWidth / 2 > clickedPos) { // set decision point to the center of the letter
					moveCursorTo(i);
					break;
				}
			}
			if (wide < clickedPos) { // in case clicked beyond last letter - set cursor to end
				moveCursorTo(Text.length());
			}
		}
		// end cursor by clicking

		this.Focus();
		cursorTime = papplet.millis();
		displayCurs = true;
		update();
	}

	@Override
	public void onKeyPress(KeyEvent e) {
		if (Enabled) {
			char Key = e.getKey();
			int Code = e.getKeyCode();

			if (Key == PApplet.CODED) {
				switch (Code) {
				case PApplet.LEFT:
					moveCursorBy(-1);
					break;
				case PApplet.RIGHT:
					moveCursorBy(1);
					break;
				case 35: // END
					moveCursorTo(Text.length());
					break;
				case 36: // pos1
					moveCursorTo(0);
					break;
				}
			} else { // not coded
				switch (Key) {
				case PApplet.BACKSPACE:
					backspace();
					break;
				case PApplet.DELETE:
					delete();
					break;
				case PApplet.ENTER:
					this.Blur();
					update();
					break;
				default:
					append(Key);
				}
			}
		}
	}
}
*/