package pGUI.core;

import processing.core.*;
import processing.event.*;

import pGUI.classes.*;

public class VFlowContainer extends Container {

	VFlowContainer(PApplet pa) {
		super(pa);
	}

	@Override
	protected void render() {
		// if AutoSize is on, first get minimal dimensions
		if (AutoSize) {
			setAutoSize();
		}

		pg = papplet.createGraphics(Width, Height);
		pg.beginDraw();
		drawDefaultBackground();

		int usedSpace = PaddingTop;

		for (int i = 0; i < Content.size(); i++) {
			Control c = Content.get(i);

			if (c.Visible) {
				// set bounds of child so it has absolute values for listener processing
				c.Bounds.X0 = this.Bounds.X0 + c.MarginLeft + PaddingLeft;
				c.Bounds.Y0 = this.Bounds.Y0 + usedSpace + c.MarginTop;

				// crop overflow
				c.Bounds.X = Math.min(c.Bounds.X0 + c.Width, this.Bounds.X);
				c.Bounds.Y = Math.min(c.Bounds.Y0 + c.Height, this.Bounds.Y);

				// constrain after computing X,Y so no data will be lost by constraining
				c.Bounds.X0 = Math.max(c.Bounds.X0, this.Bounds.X0);
				c.Bounds.Y0 = Math.max(c.Bounds.Y0, this.Bounds.Y0);

				if (c.changedVisuals) {
					c.changedVisuals = false;
					c.render();
				}

				pg.image(c.getGraphics(), c.MarginLeft + PaddingLeft, usedSpace + c.MarginTop);
				usedSpace += (c.Height + c.MarginTop + c.MarginBottom);
			}
		}

		pg.endDraw();
	}
}