/*
 *    SETTINGS
 */

int hue = 80;
int sat = 70;
int bri = 120;
/*    */boolean  debugMode = false;       //when true some debugging values will be shown on the screen

/*    */boolean  useMouse = true;         //when true then use mouse for controlling; else only eyes through camera

/*    */int      generalFrameRate = 20;


//int camNumber = 25; //microsoft

//int camNumber = 40;   //logitech
//int camNumber = 17;   //logitech at home


/*    */int      camNumber = 0;  //asus integrated

/*    */boolean  liveUneditedVideo = false;    //show the images from camera on the screen - unedited

/*    */boolean  liveOutput = false;            //show the results of graphic algorithms and searching iterations live on the screen

/*    */boolean  fastCam = false;              //don't check for cameras in the first place - just connect to a specified one; reduces start-up time


//        Interface

/*    */color    textColor = 180;

/*    */color    calibBGColor = 20;              //background color while calibration process is going on





/*
 * (some) IMPORTANT GLOBAL VARIABLES
 */

//(not really used anymore)
Rectangle feature = new Rectangle(50, 50, 100, 100);    //contains data for the position of the selected eye

Direction dir;                                          //contains data for the direction currently and previously looked at

color background = #BBBBBB;

boolean darkMode = false;                               //dark/light theme for application


/*
 * (some) IMPORTANT GLOBAL OBJECTS
 */

Notifier notifier;

CamContainer camera;
EyeTracker tracker;
FlexSensor flexSensor;









/*
 *
 *    EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS
 *
 *
 *    EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS
 *
 *
 *    EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS - EVENTS
 *
 *
 */

boolean ctrl, shft, alt = false;


void mouseEvent(MouseEvent e) {
  if (e.getAction() == MouseEvent.WHEEL) {

    if (tracker.calibratingStage == 1) { //only when detecting features
      tracker.fd.setTolerance(-e.getCount());
    }
  } else if ( e.getAction() == MouseEvent.PRESS) {
    if (tracker != null) {
      if (tracker.calibratingStage == 1) {
        if (tracker.fd.focusedFeature) {
          for (int i = 0; i < tracker.fd.features.length; i++) {
            if ((mouseX-camera.imgCenterX > tracker.fd.features[i].x) && (mouseX-camera.imgCenterX < tracker.fd.features[i].x+tracker.fd.features[i].width) && (mouseY-camera.imgCenterY > tracker.fd.features[i].y) && (mouseY-camera.imgCenterY < tracker.fd.features[i].y+tracker.fd.features[i].height)) {
              tracker.fd.featurePlane.rect(tracker.fd.features[i].x, tracker.fd.features[i].y, tracker.fd.features[i].width, tracker.fd.features[i].height);
              tracker.feature = tracker.fd.features[i];

              tracker.irisDiameter = feature.width/3;
              tracker.gg.param2 = feature.width/3;
              tracker.calibratingStage++;
              break;
            }
          }
        }
      }
    }
  } else if (e.getAction() == MouseEvent.MOVE) {

    if (tracker != null) {
      tracker.gg.param1 = int(mouseX/(float)width*255)+1;
      tracker.gg.param2 = int(mouseY/(float)height*80)+1;
    }
  }
}

void keyEvent(KeyEvent e) {
  if (e.getAction() == KeyEvent.PRESS && tracker != null) {

    switch(keyCode) {
    case 10:  //enter
      if (tracker.calibratingStage == 0 || tracker.calibratingStage == 2)
        tracker.calibratingStage++;
      break;
    case 27: //esc
      exit();
      break;
    case 116: //F5
      tracker.resetCalib();
      tracker.resetCalibration2();
      break; 
    case 117: //F6
      tracker.resetRelationCalib();
      break; 
    case 38: //upaar
      if (ctrl)
        tracker.tU++;
      else
        tracker.tU--;
      break;
    case 40: //darr
      if (ctrl)
        tracker.tD++;
      else
        tracker.tD--;
      break;
    case 37: //rarr
      if (ctrl)
        tracker.tL++;
      else
        tracker.tL--;
      break;
    case 39: //larr
      if (ctrl)
        tracker.tR++;
      else
        tracker.tR--;
      break;
    case CONTROL:
      ctrl = true;
      break;
    case SHIFT:
      shft = true; 
      break;
    case ALT:
      alt = true; 
      break;
    }
  } else if (e.getAction() == KeyEvent.RELEASE) {
    switch (keyCode) {
    case CONTROL:
      ctrl = false;
      break;
    case SHIFT:
      shft = false; 
      break;
    case ALT:
      alt = false; 
      break;
    }
  }
}



/*
 *
 *
 *    USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS
 *
 *
 *    USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS
 *
 *
 *    USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS - USEFUL METHODS
 *
 *
 */







import java.awt.Point;

Point getCenterOfRect(Rectangle r) {
  int x = r.x+r.width/2;
  int y = r.y+r.height/2;
  return new Point(x, y);
}


//white border
void drawRectNoFill(Rectangle r, PGraphics p) {
  p.beginDraw();
  p.noFill();
  p.stroke(255);
  p.rect(r.x, r.y, r.width, r.height);
  p.endDraw();
}

void drawRectAsIs(Rectangle r, PGraphics p) {
  p.beginDraw();
  p.rect(r.x, r.y, r.width, r.height);
  p.endDraw();
}

void rect(Rectangle r, PGraphics p, boolean fill, color border) {
  p.beginDraw();
  if (fill) {
    p.fill(255);
  } else {
    p.noFill();
  }
  p.stroke(border);
  p.rect(r.x, r.y, r.width, r.height);
  p.endDraw();
}

void rect(Rectangle r) {
  rect(r.x, r.x, r.width, r.height);
}


void text(String text, int size, int x, int y, color clr) {
  textSize(size);
  textAlign(LEFT, BASELINE);
  fill(clr);
  text(text, x, y);
}
