PostFrame frame;

OpenMultilineTextbox textArea;
TextView textLine;

Button closeButton;
Button capsIndicator;

Switch darkModeSwitch;
Switch showScreensSwitch;
Switch turnOffSensorSwitch;
Switch liveCamSwitch;
Container switchContainer;

ListView listview;




ECScreen nav;
ECScreen abc;
ECScreen numbers;
ECScreen settings;
ECScreen file;

PImage windowIcon;


/*
 *  Initialize the GUI
 */

void setupVisuals() {
  frame = new PostFrame(this);
  textArea = new OpenMultilineTextbox(this);
  textLine = new TextView(this, width/3 + 10);
  closeButton = new Button(this);
  capsIndicator = new Button(this);
  darkModeSwitch = new Switch(this);
  showScreensSwitch = new Switch(this);
  turnOffSensorSwitch = new Switch(this);
  liveCamSwitch = new Switch(this);
  switchContainer = new Container(this);
  listview = new ListView(this);

  frame.setSize(width, height);
  frame.setBackgroundColor(color(0, 0));
  frame.add(textArea);
  frame.add(textLine);
  frame.add(closeButton);
  frame.add(switchContainer);
  frame.add(listview);
  frame.add(capsIndicator);
  frame.setVisible(false);

  textArea.setFontSize(18);
  textArea.setPadding(10);
  textArea.setSize(width/3 + 5, height/3 + 5);
  textArea.setX(width/3 - 5);
  textArea.setY(height/3);
  textArea.setBackgroundColor( color(40, 0, 0, 100));
  textArea.setBorderWidth(1);
  textArea.setScrollSpeed(20);
  textArea.setForegroundColor(color(200));
  textArea.setCursorColor(color(200));
  textArea.Focus();
  textArea.setEnabled(false);

  textLine.setX(width/3-5);
  textLine.setHeight(20);
  textLine.setY(2 * height/3 + 4);
  textLine.setFontSize(textArea.getFontSize());
  textLine.Transparent = false;
  textLine.setBackgroundColor(color(0, 50));
  
  listview.setPosition(width/3, height/6);
  listview.setSize(width/3, 4*height/6);
  listview.setFontSize(30);
  listview.setItemBackgroundColor(color(230));
  listview.setVisible(false);
  listview.setTextAlign(LEFT);
  listview.setSelectionColor(100);

  closeButton.setText("x");
  closeButton.setMinWidth(40);
  closeButton.setMaxHeight(25);
  closeButton.setX(width-40);
  closeButton.setBackgroundColor(color(180, 130, 130));
  closeButton.setForegroundColor(color(255));
  closeButton.setFontSize(17);
  closeButton.addEventListener("press", "closeBtnPressed");
  closeButton.setY(-2);


  PImage capsImage;
  capsImage = loadImage("capsImage.png");
  capsIndicator.setImage(capsImage);
  capsIndicator.setMinWidth(35);
  capsIndicator.setMaxHeight(35);
  capsIndicator.setPosition(width/3 - 40, height/3 - 1);
  capsIndicator.setVisible(false);

  darkModeSwitch.setSize(50);
  darkModeSwitch.setPosition(5*width/6 -50, height/6+45);
  darkModeSwitch.setBackgroundColor(color(250, 0));
  darkModeSwitch.setUncheckedBackgroundColor(color(230));
  darkModeSwitch.setCheckedBackgroundColor(color(100, 100, 150));

  showScreensSwitch.setSize(50);
  showScreensSwitch.setPosition(5*width/6 -50, 3*height/6+45);
  showScreensSwitch.setBackgroundColor(color(250, 0));
  showScreensSwitch.setUncheckedBackgroundColor(color(230));
  showScreensSwitch.setCheckedBackgroundColor(color(100, 100, 150));
  showScreensSwitch.setChecked(true);

  turnOffSensorSwitch.setSize(50);
  turnOffSensorSwitch.setPosition(1*width/6 -50, 3*height/6+45);
  turnOffSensorSwitch.setBackgroundColor(color(250, 0));
  turnOffSensorSwitch.setUncheckedBackgroundColor(color(230));
  turnOffSensorSwitch.setCheckedBackgroundColor(color(100, 100, 150));

  liveCamSwitch.setSize(50);
  liveCamSwitch.setPosition(3*width/6 -50, height/6+45);
  liveCamSwitch.setBackgroundColor(color(250, 0));
  liveCamSwitch.setUncheckedBackgroundColor(color(230));
  liveCamSwitch.setCheckedBackgroundColor(color(100, 100, 150));

  switchContainer.setSize(width, height);
  switchContainer.setBackgroundColor(0);
  switchContainer.add(darkModeSwitch);
  switchContainer.add(showScreensSwitch);
  switchContainer.add(turnOffSensorSwitch);
  switchContainer.add(liveCamSwitch);
  switchContainer.setVisible(false);

  frame.setParentFrame();


  textSize(60);
  setupECScreens();

  windowIcon = loadImage("icon.png");
  surface.setIcon(windowIcon);
  surface.setTitle("iContact");
}




void setupECScreens() {
  try {
    nav = new ECScreen("Screens\\nav.txt", 0, 50);
    abc = new ECScreen("Screens\\abc.txt", 1, 50);
    numbers = new ECScreen("Screens\\numbers.txt", 2, 50);
    settings = new ECScreen("Screens\\settings.txt", 3, 40);
    file = new ECScreen("Screens\\file.txt", 4, 40);
  } 
  catch (Exception e) {
    e.printStackTrace();
  }
  ECScreenConstants.setActiveScreen(0);
}



void closeBtnPressed() {
  exit();
}
