void analyzeEyeData() {
  if (!useMouse) {

    if (dir.lastFrameDir == dir.current) {                         //only count when direction is the same as last frame; else reset to one
      dir.measure++;
    } else {
      dir.measure = 1;
    }
    if (dir.measure == 2) {                           //when measured same direction 3 times evaluate the data
      interpretEyeData(dir, false);
    }
    if (debugMode) {
      text(dir.current, width/2+50, height/2+50);
      text(dir.previous, width/2+100, height/2+50);
    }
    dir.lastFrameDir = dir.current;                                //save the current direction in lastDir
  }
}


void analyzeArduinoData() {
  switch(flexSensor.signal) {
  case FlexSensor.NULL:
    //interpretEyeData(direction.current, false);
    break;
  case FlexSensor.SHORT:
    interpretEyeData(dir, true);
    if (debugMode) {
      notifier.setNotification("short", 500);
    }
    break;
  case FlexSensor.LONG:
    goToNavigationScreen();
    if (debugMode) {
      notifier.setNotification("long", 500);
    }
    break;
  }
}



void mouseClicked() {
  if (mouseButton == LEFT) {
    int x = 3*mouseX/width;
    int y = 3*mouseY/height;
    dir.current = x+3*y;
    interpretEyeData(dir, true);
  } else { //right mouse button
    goToNavigationScreen();
  }
}



//testing the controlling with the mouse
void analyzeMouseMovement() {                  //evt besser mit ellipsen statt rechtecken simulieren
  if (useMouse) {
    int dirX = 3*mouseX/width;                    //x-direction in this frame
    int dirY = 3*mouseY/height;                   //y-direction in this frame

    dir.current = 3*dirY + dirX;                      //resulting total direction in this frame
    //text(measure, 90, 90);
    if (dir.lastFrameDir == dir.current) {                         //only count when direction is the same as last frame; else reset to one
      dir.measure++;
    } else {
      dir.measure = 1;
    }
    if (dir.measure == 6) {                           //when measured same direction 3 times evaluate the data
      interpretEyeData(dir, false);
    }
    if (debugMode) {
      text(dir.current, 500, 90);
      text(dir.previous, 550, 90);
    }
    dir.lastFrameDir = dir.current;                                //save the current direction in lastDir
  }
}








String input = "";
void keyPressed() {
  if (key != '\n') {
    input += key;
    if (key != CODED) {
      String a = "";
      a += key;
      textLine.append(a);
    }
  } else {
    println("writing \"" + input + "\"");

    try {
      flexSensor.port.write(input + "\n");
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    input = "";
  }
  switch(keyCode) {
  case 37:
    textLine.moveCursor(-1);
    break;
  case 39:
    textLine.moveCursor(1);
    break;
  }
}
