class Direction {
  int current = 4;
  int previous = 4;
  int lastFrameDir;

  int measure = 0;
}



boolean  caps = false; //when true next character will be printed in upper case

void interpretEyeData(Direction dir, boolean mouseIsPressed) { 
  //previousDir = direction.previous;

  switch(ECScreenConstants.getActiveScreenId()) { //interpreting differs from screen to screen
  case 0: //NAVIGATION SCHREEN
    eyeDataNav(dir, mouseIsPressed);
    break;
  case 1: //ABC SCREEN
    eyeDataABC(dir, mouseIsPressed);
    break;
  case 2: //NUMBER SCREEN
    eyeDataNumbers(dir, mouseIsPressed);
    break;
  case 3: //SETTINGS SCREEN
    eyeDataSettings(dir, mouseIsPressed);
    break;
  case 4: //FILE MANAGING SCREEN
    eyeDataFile(dir, mouseIsPressed);
    break;
  }
}

char interpreterNUMBERS[][] = {
  {0, '2', 0, '1', 0, '3', 0, '4', 0 }, 
  {0, '6', 0, '5', 0, '7', 0, '8', 0 }, 
  {0, '0', 0, '9', 0, '!', 0, '?', 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, '@', 0, '/', 0, '\\', 0, '#', 0 }, 
  {0, '=', 0, '+', 0, '-', '(', '\'', ')' }, 
  {0, '.', 0, ':', 0, ';', 0, ',', 0 }
};
char interpreterABC[][] = {
  {0, 'b', 0, 'a', 0, 'c', 0, 'd', 0 }, 
  {0, 'f', 0, 'e', 0, 'g', 0, 'h', 0 }, 
  {0, 'j', 0, 'i', 0, 'k', 0, 'l', 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, 'n', 0, 'm', 0, 'o', ',', 'p', '.' }, 
  {0, 'r', 0, 'q', 0, 's', 0, 't', 0 }, 
  {0, 'v', 0, 'u', 0, 'w', 'y', 'x', 'z'}
};


void goToNavigationScreen() {
  ECScreenConstants.setActiveScreen(0);
  textArea.setVisible(false);
  dir.previous = 4;
  listview.setVisible(false); 
  switchContainer.setVisible(false);
  cursor(0);
}



void eyeDataNav(Direction dir, boolean mouseWasPressed) {
  switchContainer.setVisible(false);
  listview.setVisible(false);
  textArea.setVisible(false);
  if (mouseWasPressed) { //only when pressed change screen (select-press mode);
    switch(dir.current) {
    case 0:
      ECScreenConstants.setActiveScreen(1); //ABC Screen
      textArea.setVisible(true);
      break; 
    case 1: 
      ECScreenConstants.setActiveScreen(3); //Settings Screen

      switchContainer.setVisible(true);
      break; 
    case 3: 
      ECScreenConstants.setActiveScreen(2); //Numbers Screen
      textArea.setVisible(true);
      break; 
    case 4:
      ECScreenConstants.setActiveScreen(5); //Commands Screen (non-existent)
      break; 
    case 6:
      ECScreenConstants.setActiveScreen(4); //File Screen
      listview.setVisible(true);
      break;
    }
    dir.previous = 4;
  }
}




void eyeDataABC(Direction dir, boolean mouseWasPressed) {
  if (mouseWasPressed) {
    switch(dir.current) {
    case 5:       //right -> Space
      textLine.append(" ");
      textArea.append(" ");
      break;
    case 3:       //left -> Delete
      textLine.deleteAtCursor();
      textArea.backspace();
      break;
    case 1:       //top -> Capital letter
      caps = true;
      capsIndicator.setVisible(true);
      break;
    case 7:       //bottom -> Return
      textLine.append(" ");
      textArea.append("\n");
      break;
    case 4: //reset directions
      dir.previous = 4;
      dir.current = 4;
      break;
    }
    dir.previous = 4;
    //previousDir = 4;
  } else { //mouse was not pressed
    if (dir.previous != 4 && dir.current != 4) { //both not center
      String add = str(interpreterABC[dir.previous][dir.current]);
      if (!add.equals("\0")) { //check if character had a value other than 0
        textLine.append(caps? add.toUpperCase() : add);
        textArea.append(caps? add.toUpperCase() : add);
        caps = false;
        capsIndicator.setVisible(false);
      }
      dir.previous = 4;
      //previousDir = 4;
    } else if (dir.previous != 4 && dir.current == 4 || dir.current == 3 || dir.current == 5) { //don't overwrite previousDir when direction is not suitable
    } else {
      //previousDir = dir;
      dir.previous = dir.current;
    }
  }
}




void eyeDataNumbers(Direction dir, boolean mouseIsPressed) {
  if (mouseIsPressed) {
    switch(dir.current) {
    case 5:       //right -> Space
      textLine.append(" ");
      textArea.append(" ");
      break;
    case 3:       //left -> Delete
      textLine.deleteAtCursor();
      textArea.backspace();
      break;
    case 1:       //top -> Capital letter
      caps = true;
      break;
    case 7:       //bottom -> Return
      textLine.append(" ");
      textArea.append("\n");
      break;
    case 4:       //reset directions
      dir.previous = 4;
      dir.current = 4;
      break;
    }
    dir.previous = 4;
  } else {        //mouse was not pressed

    if (dir.previous != 4 && dir.current != 4) { //both not center
      String add = str(interpreterNUMBERS[dir.previous][dir.current]);
      if (!add.equals("\0")) { //check if character had a value other than 0
        textLine.append(add);
        textArea.append(caps? add.toUpperCase() : add);
      }
      dir.previous = 4;
    } else if (dir.previous != 4 && dir.current == 4 || dir.current == 3 || dir.current == 5) { //don't overwrite previousDir when direction is not suitable
    } else {
      dir.previous = dir.current;
    }
  }
}




void eyeDataSettings(Direction dir, boolean mouseIsPressed) {
  if (mouseIsPressed) { //only when pressed change screen (select-press mode);

    switch(dir.current) {
    case 0: //recalibrate sensor
      if (flexSensor.connected) {
        flexSensor.recalibrate();
        notifier.setNotification("Recalibrating...", 1000);
      } else {
        notifier.setNotification("No sensor connected", 1000);
      }
      break; 

    case 1: //hide/show live cam
      liveUneditedVideo = !liveUneditedVideo;
      liveCamSwitch.setChecked(liveUneditedVideo);
      break; 

    case 2: //light/dark mode
      darkMode = !darkMode;
      darkModeSwitch.setChecked(darkMode);
      if (darkMode) {
        notifier.setNotification("Changed to dark mode", 1000);
      setting.updateSettings(3, "true");
      } else {
        notifier.setNotification("Changed to light mode", 1000);
      setting.updateSettings(3, "false");
      }
      break;

    case 3: //sleep/wake sensor
      if (flexSensor.connected) {
        if (flexSensor.sleeping) {
          flexSensor.wake();
          notifier.setNotification("Awaked sensor", 1000);
        } else {
          flexSensor.sleep();
          notifier.setNotification("Set sensor to sleep", 1000);
        }
      } else {
        notifier.setNotification("Not available, no sensor connected", 1000);
      }
      turnOffSensorSwitch.setChecked(flexSensor.sleeping);
      break; 

    case 4:
      break; 

    case 5:  //enable / disable ecscreens (only for abc, nums);
      abc.visible = !abc.visible;
      numbers.visible = !numbers.visible;
      showScreensSwitch.setChecked(numbers.visible);
      println(abc.visible, numbers.visible);
      break;

    case 6:
      break;

    case 8: //close application
      exit();
      break;
    }
    dir.previous = 4;
  }
}







//file Screen
void eyeDataFile(Direction dir, boolean mouseWasPressed) 
{
  if (mouseWasPressed) 
  { //only when pressed change screen (select-press mode);
    switch(dir.current) 
    {
    case 0:  //Save current
      setting.saveCurrentFile(1);
      setting.load = false;
      break; 
    case 1:  //txt-file 1
      //setting.actionFile();
      break; 
    case 2:  //up
      setting.updateFileScreen(1);
      break;
    case 3:  //delete
      setting.activateAction(1);
      break;
    case 4:  //txt-file 2
      break;
    case 5:  
      break;
    case 6:  //load
      //setting.activateAction(2);
      setting.loadFile(1);
      textArea.setCursorPosition(0);
      switchContainer.setVisible(false);
      listview.setVisible(false);
      textArea.setVisible(false);
      goToNavigationScreen();
      ECScreenConstants.setActiveScreen(1); //ABC Screen
      textArea.setVisible(true);
      break;
    case 7:  //txt-file 3
      //setting.actionFile();
      break;
    case 8:  //down
      setting.updateFileScreen(0);
      break;
    }
  }
}
