


//Bacically no used anymore !!!

/*
 * The Feature-Detection class can be used to detect features like eyes and faces using 
 * the OpenCV library for Processing (by Greg Borenstein). 
 * 
 * When creating an instance it is necessary to pass the parent PApplet (referred to by this in main code) and the mode to be used
 * Modes can be EYE (for eye recognition) or FACE (for face recognition)
 * 
 */


import gab.opencv.*;
import java.awt.Rectangle;

public static final String EYE = "eye";
public static final String FACE = "facs";
public static final String NOSE = "nose";



class FeatureDetection {

  private OpenCV opencv;
  private OpenCV opencvNose;
  private PGraphics featurePlane;
  private Rectangle[] features;             //contain coords for all detected features of last detection 
  private int tolerance;                    //detection tolerance (neighbors)
  private boolean focusedFeature = false;   //true, when mouse hovers over detected feature
  private int posX = 0;                     //relative to image corner
  private int posY = 0;                     //relative to image corner
  private boolean isInitialized = false;

  FeatureDetection(PApplet pa, String mode, int w, int h) {
    this.opencv = new OpenCV(pa, w, h);
    this.opencvNose = new OpenCV(pa, w, h);
    if (mode == "face") {
      this.opencv.loadCascade(OpenCV.CASCADE_FRONTALFACE);
    } else if (mode == "eye") {
      this.opencv.loadCascade(OpenCV.CASCADE_EYE);
    } else if (mode == "nose") {
      this.opencv.loadCascade(OpenCV.CASCADE_NOSE);
    }
    this.opencvNose.loadCascade(OpenCV.CASCADE_NOSE);
    this.featurePlane = createGraphics(width, height);
    this.tolerance = 15;
    isInitialized = true;
  }

  Rectangle[] detect(boolean displayRect, CamContainer cc, int calibratingStage) { 
    this.opencv.loadImage(cc.cam);
    this.features = opencv.detect(2, this.tolerance, 10, 60, 200);
    /*detect(double scaleFactor, int minNeighbors, int flags, int minSize, int maxSize)*/
    this.featurePlane.beginDraw();
    this.featurePlane.clear();
    this.featurePlane.noFill();
    this.featurePlane.stroke(66, 134, 244);
    this.featurePlane.strokeWeight(1);
    for (int i = 0; i < this.features.length; i++) {
      if (displayRect) {
        this.featurePlane.rect(this.features[i].x, this.features[i].y, this.features[i].width, this.features[i].height);
      }
    }

    //draw red rectangle when mouse hovers over feature
    if (calibratingStage == 1) {
      colorMode(RGB, 255);
      focusedFeature = false;
      featurePlane.fill(66, 134, 244, 150);
      for (int i = 0; i < features.length; i++) {
        if ((mouseX-this.posX > this.features[i].x) && (mouseX-this.posX < this.features[i].x+this.features[i].width) && (mouseY-this.posY > this.features[i].y) && (mouseY-this.posY < this.features[i].y+features[i].height)) {
          this.featurePlane.rect(this.features[i].x, features[i].y, this.features[i].width, this.features[i].height);
          this.focusedFeature = true;
        }
      }
    }
    this.featurePlane.endDraw();

    image(this.featurePlane, this.posX, this.posY);
    if (this.features.length > 0) {
      return this.features;
    } else {
      return this.features;
    }
  }




  Rectangle[] detectNose(CamContainer cc) { 
    this.opencvNose.loadImage(cc.cam);
    return opencvNose.detect(2, this.tolerance, 10, 60, 400);
  }




  void setPosition(int x, int y) {
    this.posX = x;
    this.posY = y;
  }

  void setTolerance(int tolerance) {
    this.tolerance = max(0, this.tolerance + tolerance); //avoid values below 0
  }

  int getTolerance() {
    return this.tolerance;
  }

  boolean isInitialized() {
    return isInitialized;
  }
}
