import java.util.Date;
import java.io.File;

class Settings
{
  //------------------------Attributes-------------------------------------------------

  //settings
  StringList txtNames = new StringList();             //holds all file-names
  String filename;                                    //current filename
  String[] filedata = new String[4];                  //holds nessesary filedata
  int oldTime = 0;                                    //counts minutes up to 5 to save
  int passedMinutes = 0;                              //counts minutes 
  ECScreen beSure = new ECScreen("Screens\\nav.txt", 0, 50);
  //filescreen
  boolean load = false;                               //shows if load was pressed
  boolean delete = false;
  //-----------------------Konstruktors------------------------------------------------
  Settings()
  { 
    oldTime = minute();
    //get all names form txt files
    try
    {
      String path = sketchPath("data\\txt_files");
      String[] filenames = listFileNames(path);
      for (int i = 0; i < filenames.length; i++)
      {
        txtNames.append(filenames[i]);
        listview.add(filenames[i]);
      }
    }
    catch(Exception e) //directory doesn't exist
    {
      File f = new File("Desktop");
      //saveStrings("data/" + '/' + "txt_files/" + '/' + filename + '.' + "txt",placeholder);
      if (f.mkdirs() == false)
      {
        e.printStackTrace();
        exit();
      }
    }
    readSettings();
  }

  //------------------------Methodes-------------------------------//
  //changes Attributes if necessary

  void readSettings()
  {
    try 
    {
      filedata = loadStrings("data\\settings.txt");
      //change darkmode
      if (filedata[2].equals("darkmode: false"))
      {
        darkMode = false;
        darkModeSwitch.setChecked(false);
      } else
      {
        darkMode = true;
        darkModeSwitch.setChecked(true);
      }
      //change framedata
      //String[] enterContentOccurrences = match(filedata[1], "(?<=enterContent=\")([0-9])+(?=\")");
      //frameRate(parseFloat(enterContentOccurrences[0]));

      //load savestate
      if (filedata[3] == "savestate: false")
      {
        loadFile(0);
      }

      //change background
      String sub = filedata[1].substring(11);
      String colorint[] = sub.split(",");
      colorMode(RGB, 255);
      println("f",int(trim(colorint[0])),int(trim(colorint[1])),int(trim(colorint[2])));
      background = color(int(trim(colorint[0])),int(trim(colorint[1])),int(trim(colorint[2])));
    } 
    catch (Exception e) 
    {
      e.printStackTrace();
      //creates settings
      filedata = new String[4];
      updateSettings(1, "10");
      updateSettings(2, "100,100,100");
      updateSettings(3, str(darkMode));
      notifier.setNotification("Setting not found", 2000);
    }
  }

  /*
      1 for framerate
   2 for background
   3 for darkmode
   4 for savestate
   changes and saves settings.txt*/
  void updateSettings(int position, String str)
  {
    //darkmode
    switch(position)
    {
    case 0:

      break;
    case 1:
      //framerate
      filedata[position-1] = "framerate: " + str; 
      break;
    case 2:
      //background
      filedata[position-1] = "background: " + str; 
      break;
    case 3:
      //darkmode
      filedata[position-1] = "darkmode: " + str; 
      break;
    case 4:
      //adds filename to Settings.txt
      filedata[position-1] = "savestate: " + str; 
      break;
    }
    saveStrings("data\\settings.txt", filedata);
  }

  //changes displayed File-names //up and down
  void updateFileScreen(int direction)
  {
    //up
    if (direction == 0 )
      listview.setSelectedItem(listview.getSelectionIndex()+1);
    //down
    else if (direction == 1)
      listview.setSelectedItem(listview.getSelectionIndex()-1);
    listview.scrollToItem(listview.getSelectionIndex());
    notifier.setNotification(listview.getSelectedItem().getText(), 1000);
  }

  //saves current Content // save as
  void saveCurrentFile(int state)
  {
    //text is available
    if (textArea.getText() != "")
    {
      //copys text into placeholder
      String textLines[] = split(textArea.getText(), "\n");
      //new filename is first line
      filename =  trim(textLines[0]) + ".txt";

      try
      {
        if (state == 0)
        {
          saveStrings("data//txt_files//savestate.txt", textLines);
        } else
        {
          saveStrings("data//txt_files//" + filename, textLines);
          updateSettings(4, filename);
          notifier.setNotification("File successfully saved", 1000);
          boolean exist = false;
          for (int i = 0; i < txtNames.size(); i++)
          {
            if (filename.equals(txtNames.get(i)))
            {
              notifier.setNotification("Name exists already", 1000);
              exist = true;
              break;
            }
          }
          if (exist == false)
          {
            notifier.setNotification("Name added", 1000);
            txtNames.append(filename);
            listview.add(filename);
            listview.setCursor(0);
          }
        }
      }
      catch(Exception e)
      {
        notifier.setNotification("Couldn't save File", 1000);
      }
    } else
    {
      notifier.setNotification("No text available.", 2000);
    }
  }

  //happen if delete/load is pressed and activates the action
  void activateAction(int action)
  {
    if (action == 1)
    {
      if (this.load == true)
        this.load = false;
      this.delete = true;
    } else
    {
      if (this.delete == true)
        this.delete = false;
      this.load = true;
    }
    notifier.setNotification("Select the file", 1000);
  }

  //performs activated action
  void actionFile()
  {
    if (load == true)
    {
      loadFile(1);
      load = false;
    } else
      notifier.setNotification("Please select an action first", 1000);
  }

  //load file content into mlineText 1->up 2->down
  void loadFile(int state)
  {
    String path = "";
    //load savestate
    if (state == 0)
    {
      path = "data/" + '/' + "savestate.txt";
    }
    //load file
    else
    {
      path = "data/" + '/' + "txt_files/" + '/' + listview.getSelectedItem().getText();
    }
    String placeholder = "";
    for (int i= 0; i < convertA2L(loadStrings(path)).size(); i++)
    {
      placeholder += convertA2L(loadStrings(path)).get(i);
    }
    textArea.setText(placeholder);
    load = false;
    notifier.setNotification("File loaded", 1000);
  }

  void timeCompare (int newTime)
  {
    //5 minutes ahead of oldtime
    if ((oldTime > 54 && newTime == oldTime - 59 +5) || (oldTime <= 54 && newTime == oldTime+5))
    {
      saveCurrentFile(0);
      oldTime = newTime;
      notifier.setNotification("Savestate updated", 1000);
    }
  }

  StringList convertA2L(String[] array)
  {
    StringList placeholder = new StringList();
    for (int i = 0; i < array.length; i++)
    {
      placeholder.append(array[i]);
    }
    printArray(placeholder);
    return placeholder;
  }

  //---------------------------------------------------------------------------------------------------------------copied
  // This function returns all the files in a directory as an array of Strings  
  String[] listFileNames(String dir) 
  {
    File file = new File(dir);
    if (file.isDirectory()) 
    {
      String names[] = file.list();
      return names;
    } else 
    {
      // If it's not a directory
      return null;
    }
  }

  // This function returns all the files in a directory as an array of File objects
  // This is useful if you want more info about the file
  File[] listFiles(String dir) 
  {
    File file = new File(dir);
    if (file.isDirectory()) 
    {
      File[] files = file.listFiles();
      return files;
    } else 
    {
      // If it's not a directory
      return null;
    }
  }
}
