/*
 *
 * The MultilineTextBox is part of the gui library for processing created by me.
 * 
 * Like the name says it's a textbox that registers keystrokes when having been clicked on and inserts the keys. 
 * When reaching the end of a line it automatically breaks the line and scrolls down if the total height of the text exceeds the objects height. 
 *
 * Don't expect to be able select any text or set the cursor with the mouse! (; (everything's done manually here)
 *    (arrow keys work though, so do backspace and del)
 *
 *
 *
 *
 */

class OpenMultilineTextbox extends MultilineTextbox {  
  OpenMultilineTextbox(PApplet pa) {
    super(pa);
  }

  public void backspace() {
    super.backspace();
  }
  public void append(char c) {
    super.append(c);
  }
  public void append(String c) {
    super.append(c);
  }
  public void deleteKey() {
    super.deleteKey();
  }
}

public class PostFrame extends Frame {
  public PostFrame(PApplet pa) {
    super(pa);
    papplet = pa;
    frame = this;
    papplet.registerMethod("draw", this);
    //default size fills out entire sketch window
    setSize(papplet.width, papplet.height);
    pg = createGraphics(width, height);
  }
  public void draw() {

    int t = millis();
    this.display();
    timeKeeper.add(millis()-t, "GUI");
  }
  public void pre() {
  }
  public void update() {
    int t = millis();
    super.update();
    //println("G",(millis()-t));
  }

  int p = 0;
  public void display() {
    if (Visible) {
      if (changedVisuals) {
        changedVisuals = false;
        render();
      }
      //papplet.set(0, 0, pg); // ist wirklich am schnellsten
      papplet.image(pg, 0, 0); //muss sein, da set die transparenzen nicht beachtet
    }
  }
}





public class TextView extends Control {

  public boolean Transparent = true;
  String Text = "";                             //current word 
  protected int cursor = 0;                     //position of cursor in paragraph

  TextView(PApplet pa, int Width) {
    super(pa);
    Name = "LABEL";
    VisualBackgroundColor = color(0, 0);

    this.Width = Width;
    MaxHeight = 100;
    Height = 60;
    pg = createGraphics(Width, Height);
    setPadding(10);
  }


  /*
   *append at cursor
   */
  void append(String s) {
    cursor += s.length();
    if (s == " ") {
      Text = "";
      cursor = 0;
    } else {
      Text = Text.substring(0, cursor-1) + s + Text.substring(cursor-1);
    }
    update();
  }

  @Override 
    public void render() {
    pg = createGraphics(Width, Height);
    pg.beginDraw();
    pg.clear();

    if (Transparent) {
      pg.noFill();
    } else {
      pg.fill(VisualBackgroundColor);
    }
    pg.stroke(40);

    pg.rect(BorderWidth, BorderWidth, Width - 2 * BorderWidth, Height - 2 * BorderWidth);

    pg.noStroke();
    pg.textSize(FontSize);
    pg.fill(ForegroundColor);
    pg.textAlign(LEFT, CENTER);
    pg.text(Text, PaddingLeft, Height/2);
    drawCursor();
    pg.endDraw();
  }




  void drawCursor() {
    float wordWidth = pg.textWidth(Text.substring(0, cursor))+2;
    pg.stroke(0);
    pg.line(wordWidth + PaddingLeft, 10, wordWidth + PaddingLeft, FontSize + 10);
  }

  void moveCursor(int i) {
    cursor = constrain(cursor + i, 0, Text.length());
    update();
  }

  void deleteAtCursor() {
    if (Text.length() > 0 && cursor >= 1) {
      Text = Text.substring(0, cursor-1) + Text.substring(cursor);
      cursor--;
      update();
    }
  }




  //@override 
  void setText(String s) {
    Text = trim(s);
    autoSize();
  }


  void setFontSize(int s) {
    FontSize = s;
    autoSize();
  }


  //automatic resize control, so it fits the text
  private void autoSize() {
    pg.beginDraw();
    pg.textSize(FontSize);
    //Width = (int)constrain(pg.textWidth(Text), MinWidth, MaxWidth);
    Height = (int)constrain(FontSize + pg.textDescent() + pg.textAscent(), MinHeight, MaxHeight);
  }
}
